// tdCallLogHk.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

/* Defines */
#define APP_MUTEX				_T("tdCallLogHk App Mutex")
#define APP_STOP_EVENT			_T("tdCallLogHk Stop Event")

#define DESKTOP_WINDOW_CLASS_NAME	_T("DesktopExplorerWindow")
#define DESKTOP_WINDOW_TITLE_NAME	_T("Desktop")
#define DENWA_WINDOW_CLASS_NAME		_T("AfxFrameOrView80su")
#define DENWA_WINDOW_TITLE_NAME		_T("db ")

/* Global Variables */
static WNDPROC g_pfnOrigProc = NULL;


LRESULT
CALLBACK
SubClassProc(
	HWND	hWnd,
	UINT	msg,
	WPARAM	wParam,
	LPARAM	lParam
)
{
	HWND	hDenwa = NULL;

	if (msg == WM_KEYUP) {
		switch(wParam){
		case VK_LEFT:
			{
				hDenwa = FindWindow(DENWA_WINDOW_CLASS_NAME, DENWA_WINDOW_TITLE_NAME);

				if (hDenwa != NULL) {
					SetForegroundWindow(hDenwa);
					keybd_event(VK_F21,	0, KEYEVENTF_SILENT,0);
					keybd_event(VK_LEFT, 0, KEYEVENTF_SILENT,0);
					keybd_event(VK_LEFT, 0, KEYEVENTF_KEYUP|KEYEVENTF_SILENT,0);
					keybd_event(VK_F21,	0, KEYEVENTF_KEYUP|KEYEVENTF_SILENT,0);
				}
			}

			return 0;
			break;

		case VK_RIGHT:
			{
				hDenwa = FindWindow(DENWA_WINDOW_CLASS_NAME, DENWA_WINDOW_TITLE_NAME);

				if (hDenwa != NULL) {
					SetForegroundWindow(hDenwa);
					keybd_event(VK_F21,	0, KEYEVENTF_SILENT,0);
					keybd_event(VK_RIGHT, 0, KEYEVENTF_SILENT,0);
					keybd_event(VK_RIGHT, 0, KEYEVENTF_KEYUP|KEYEVENTF_SILENT,0);
					keybd_event(VK_F21,	0, KEYEVENTF_KEYUP|KEYEVENTF_SILENT,0);
				}
			}
			return 0;
			break;
		}
	}
	else if (msg == WM_KEYDOWN) {
		if (wParam == VK_LEFT || wParam == VK_RIGHT) {
			return 0;
		}
	}

	return CallWindowProc(g_pfnOrigProc, hWnd, msg, wParam, lParam);
}

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	HANDLE	hMutex = NULL;
	HANDLE	hStopEvent = NULL;
	HWND	hDesk = NULL;

	hMutex = CreateMutex(NULL, TRUE, APP_MUTEX);
	if (hMutex != NULL) {
		if (GetLastError() == ERROR_ALREADY_EXISTS) {
			int		iRet;

			iRet = MessageBox(NULL, _T("I܂H"), _T("tdCallLogHk"), MB_YESNO|MB_ICONQUESTION);
			if (iRet == IDYES) {
				HANDLE	hEvent;

				hEvent = OpenEvent(EVENT_ALL_ACCESS, FALSE, APP_STOP_EVENT);
				if (hEvent != NULL) {
					SetEvent(hEvent);
					CloseHandle(hEvent);
					hEvent = NULL;
				}

			}

			CloseHandle(hMutex);
			return 0;
		}
	}
	else {
		return 0;
	}

	hStopEvent = CreateEvent(NULL, FALSE, FALSE, APP_STOP_EVENT);
	if (hStopEvent != NULL) {

//		hDesk = GetDesktopWindow();
		hDesk = FindWindow(DESKTOP_WINDOW_CLASS_NAME, DESKTOP_WINDOW_TITLE_NAME);

		if (hDesk != NULL) {

			g_pfnOrigProc = (WNDPROC)GetWindowLong(hDesk, GWL_WNDPROC);

			if (g_pfnOrigProc != NULL) {
				LONG lResult;

				// vZX̃EBhESetWindowLong()łႤ̂͂ȂłCȂłD
				// MSDNɂ͂łȂďĂ̂...
				//
				// {TodayPluginƂĎǂ͂
				lResult = SetWindowLong(hDesk, GWL_WNDPROC, (LONG)SubClassProc);

				if (lResult != 0) {

					WaitForSingleObject(hStopEvent, INFINITE);

					SetWindowLong(hDesk, GWL_WNDPROC, (LONG)g_pfnOrigProc);
				}
			}
			else {
				MessageBox(NULL, _T("SetWindowLong fail"), NULL, MB_OK);
			}
		}
		else {
			MessageBox(NULL, _T("Cant find Desktop"), NULL, MB_OK);
		}

		CloseHandle(hStopEvent);
		hStopEvent = NULL;
	}


	ReleaseMutex(hMutex);
	CloseHandle(hMutex);
	return 0;
}

